#include "classes.h"

CVideo::CVideo(CMemory *pmArg,HDC *lpArg) {

	pmMemory=pmArg;
	lpHdc=lpArg;

	// DIBwb_ݒ
	biInfo.bmiHeader.biSize=sizeof(BITMAPINFOHEADER);
	biInfo.bmiHeader.biPlanes=1;
	biInfo.bmiHeader.biCompression=BI_RGB;

	// F`ETCYݒ
	setBpp(32);
	setSize(128,128);

}

I32 CVideo::getIOSize() const { return 1; }

bool CVideo::setIO(UI32 u32Arg) {

	u32IO=u32Arg;

	return true;

}

bool CVideo::setVRAM(UI32 u32Arg,I32 i32Arg) {

	u32Pixels=u32Arg;
	i32VRAMSize=i32Arg;

	return true;

}

bool CVideo::setBpp(I32 i32Arg) {

	if (i32Arg!=32)
		return false;

	i32Bytes=4;

	biInfo.bmiHeader.biBitCount=i32Arg;

	return true;

}

bool CVideo::setSize(I32 i32Arg1,I32 i32Arg2) {

	if (i32Arg1 % 4!=0 || i32Arg2 % 4!=0)
		return false;

	i32Width=i32Arg1;
	i32Height=i32Arg2;
	i32Length=i32Width*i32Bytes;

	biInfo.bmiHeader.biWidth=i32Width;
	biInfo.bmiHeader.biHeight=-i32Height;

	return true;

}

bool CVideo::proc() {

	if (pmMemory->read8(u32IO)==1) {

		StretchDIBits(*lpHdc,0,0,i32Width,i32Height,
		  0,0,i32Width,i32Height,
		  pmMemory->getBufferAddress(u32Pixels),&biInfo,
		  DIB_RGB_COLORS,SRCCOPY);

		pmMemory->write8(u32IO,0);

	}

	return true;

}
